package com.sambar.filters;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

public class PageTimerFilter implements Filter 
{
	public void init(FilterConfig filterConfig) throws ServletException 
	{
	}

	public void doFilter(ServletRequest request, ServletResponse response, 
		FilterChain chain) throws IOException, ServletException 
	{
		long runningTime = System.currentTimeMillis();
		chain.doFilter(request, response);
		runningTime = System.currentTimeMillis() - runningTime;

		response.getWriter().write("<!-- Request took ");
		response.getWriter().write(Long.toString(runningTime));
		response.getWriter().write("ms -->\n");
	}

	public void destroy() 
	{
	}
}
