/*
** 		Sambar Server JAVA Engine Implementation
**
**		Confidential Property of Tod Sambar
**		(c) Copyright Tod Sambar 1999
**		All rights reserved.
*/
package com.sambar.javaeng;

import java.io.*;
import java.net.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.sambar.javaeng.SambarAPI;

class SambarConfig implements ServletConfig
{
	public Vector				emptyVector;
	private long 				javaeng;
	private ServletConfig		extraConfig;
    protected String 			servletName;
	protected SambarContext		context;

	public SambarConfig(long javaeng, SambarContext context, String name,
		ServletConfig config) 
		throws RuntimeException
	{
		String	val;

		this.javaeng = javaeng;
		this.context = context;
		this.servletName = name;
		this.extraConfig = config;

		emptyVector = new Vector();
	}

	public String getServletName() 
	{
		return servletName;
	}

	public ServletContext getServletContext() 
	{
		return context;
	}

	public String getInitParameter(String name) 
	{
		if (extraConfig != null)
		{
			String val = extraConfig.getInitParameter(name);
			if (val != null)
				return val;
		}

		byte b[] = SambarAPI.getInitParameter(javaeng, name);
		if (b == null)
			return null;

		return new String(b);
	}

	public Enumeration getInitParameterNames()
	{
		if (extraConfig != null)
		{
			return extraConfig.getInitParameterNames();
		}

		return emptyVector.elements();
	}
}
