/*
** 		Sambar Server JAVA Engine Implementation
**
**		Confidential Property of Tod Sambar
**		(c) Copyright Tod Sambar 1999
**		All rights reserved.
*/
package com.sambar.javaeng;

import java.io.*;
import java.net.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.sambar.javaeng.SambarAPI;

class SambarOutputStream extends ServletOutputStream 
{
	private boolean 			noHeaders = true;
	private SambarConnection 	sconn;
  
	public SambarOutputStream(SambarConnection sconn)
	{
		this.sconn = sconn;
	}
  
	public void write(int b) throws IOException 
	{
		sconn.sendHttpHeaders(); 
		long req = sconn.getRequestHandle();
		if (SambarAPI.putb(req, b) == 0)
			throw new IOException("Failure to write on socket.");
	}
  
	public void write(byte b[], int off, int len) throws IOException 
	{
		int		sz;
		int		sent;

		sconn.sendHttpHeaders(); 
		long req = sconn.getRequestHandle();
		if (len <= 1024)
		{
			if (SambarAPI.puta(req, b, off, len) == 0)
				throw new IOException("Failure to write on socket.");
			return;
		}

		// Write in 1K buffers so no JNI exception
		sent = 0;
		byte[] data = new byte[1024];
		while (sent < len)
		{
			sz = Math.min(1024, len - sent);
			System.arraycopy(b, off + sent, data, 0, sz);

			if (SambarAPI.puta(req, data, 0, sz) == 0)
				throw new IOException("Failure to write on socket.");

			sent += sz;
		}
	}
  
	public void flush() throws IOException 
	{
		long req = sconn.getRequestHandle();
		if (SambarAPI.flush(req) == 0)
			throw new IOException("Failure to write on socket.");
	}
  
	public void close() throws IOException 
	{
		sconn.sendHttpHeaders(); 
	}
}
