/*
** 		Sambar Server JAVA Request Dispatcher Implementation
**
**		Confidential Property of Tod Sambar
**		(c) Copyright Tod Sambar 2000
**		All rights reserved.
*/
package com.sambar.javaeng;

import java.io.*;
import java.net.*;
import java.text.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.sambar.javaeng.SambarAPI;
import com.sambar.javaeng.SambarUtils;

class SambarRequestDispatcher implements RequestDispatcher
{
    SambarContext 	scontext;

    // path dispatchers
    String 			path = null;
    String 			queryString = null;

    // name dispatchers
    String 			name;

    SambarRequestDispatcher(SambarContext scontext) 
	{
        this.scontext = scontext;
    }

    void setPath(String urlPath) 
	{
		// separate the query string
		int i = urlPath.indexOf("?");
		if (i < 0)
		{
			this.path = urlPath;
		}
		else 
		{
			this.path = urlPath.substring(0, i);

			if (i < urlPath.length())
				this.queryString = urlPath.substring(i + 1);
        }
    }

    void setName (String name) 
	{
		this.name = name;
    }
    
    public void forward(ServletRequest request, ServletResponse response)
		throws ServletException, IOException
    {
		SambarConnection conn = (SambarConnection)request;
		long sreq = conn.getRequestHandle();	

		if (SambarAPI.wasHeaderSent(sreq) > 0)
		{
			throw new IllegalStateException("SambarRequestDispatcher: forward() unavailable, content already sent!");
		}

		String error = SambarAPI.forward((Object)conn, sreq, name, path, 
			queryString);
		if (error != null)
		{
			throw new IOException("SambarRequestDispatcher: forward(" + path + 
				") failed: " + error);
		}
    }

    public void include(ServletRequest request, ServletResponse response)
		throws ServletException, IOException
    {
		SambarConnection conn = (SambarConnection)request;

		// Flush any HTTP headers. The included content is only permitted to
		// write on the output stream according to the spec.
		conn.sendHttpHeaders();

		long sreq = conn.getRequestHandle();	

		String error = SambarAPI.include((Object)conn, sreq, name, path, 
			queryString);
		if (error != null)
		{
			throw new IOException("SambarRequestDispatcher: include(" + path + 
				") failed: " + error);
		}
    }
}
