/*
** Validate the caller is a member of the cluster
*/
clusterkey = soapParameterGet($soap, "clusterkey");
timestamp = soapParameterGet($soap, "timestamp");
try
{
	key = getClusterKey($server, (int)timestamp, envt("REMOTE_ADDR"));
}
catch (e)
{
	soapResultError($soap, "clusterKey", 
		"Invalid cluster key or timestamp provided.");
	return;
}

if (clusterkey != key)
{
	soapResultError($soap, "clusterKey", 
		"Invalid cluster key provided.");
	return;
}

/*
** Cluster status() web service handler.
*/
typedef struct status {
	char	*version;
	char	*os;
	char	*license;
	char	*licensee;
	char	*builddate;
	char	*starttime;
};

struct status result;

result.version = envt("version");
result.os = envt("os");
result.license = envt("license");
result.licensee = envt("licensee");
result.builddate = envt("builddate");
result.starttime = envt("starttime");

// Return the STATUS result to the caller.
soapResultAdd($soap, NULL, result);
