<% 
#include "check.asp"

setContentType($response, "text/calendar");

view = findParameter($params, "view", "month");

printf("BEGIN:VCALENDAR\n");
printf("VERSION:2.0\n");
printf("PRODID:-//Sambar Server//EN\n");
printf("CALSCALE:GREGORIAN\n");

t = time();
if (view == "day")
{
	date = gmstrftime(t, "%Y-%m-%d");
	rssfile = path + "/caldata/" + date + ".rss";
	showItem(rssfile);
}
else if (view == "week")
{
	wday = gmtime(t, "wday");
	for (day = 1; day < 8; day++)
	{
    	curt = t;
    	if (day < wday)
        	curt -= (86400 * (wday - day));
    	else if (day > wday)
        	curt += (86400 * (day - wday));

    	dy = gmtime(curt, "mday");
    	sprintf(curdate, "%d-%02d-%02d", 
			gmtime(curt, "year"), gmtime(curt, "mon"), dy);
		rssfile = path + "/caldata/" + curdate + ".rss";
		showItem(rssfile);
	}
}
else if (view == "month")
{
	mon = gmtime(t, "mon");
	year = gmtime(t, "year"); 
	for (day = 1; day <= 31; day++)
	{
    	sprintf(curdate, "%d-%02d-%02d", year, mon, day);
		rssfile = path + "/caldata/" + curdate + ".rss";
		showItem(rssfile);
	}
}

showItem(char *rssfile)
{
	rss = null;
	try
	{
		char *userpath = getUserPath($request, rssfile);
		if (userpath != null)
		{
			xml = XMLOpen(userpath, 0);
			if (xml != NULL)
			{
				rss = RSS(xml);
				RSSSort(rss, "startdate");
				XMLFree(xml);
			}
		}
	}
	catch (e)
	{
		write("<!--\n");
    	write(exception(e, "info"));
    	write("\n-->\n");
    	printf("RSS '%s' is not available or corrupt.", rssfile);
		exit;
	}

	if ((rss != null) && (sizeof(rss.items) > 0))
	{
		for (i = 0; i < sizeof(rss.items); i++)
		{
			rssitem = rss.items[i];
			if (sizeof(rssitem.title) == 0)
    			continue;

			title = rssitem.title;

            int rectsec = 0;
            int datetime = rssitem.pubDate;
            if (datetime > 0)
            {
                rectsec = gmtime(datetime, "tsec");
            }
            else
            {
                rectsec = gmtime(time(), "tsec");
            }

			char *pubdate = gmstrftime(rectsec, "%Y%m%dT%H%M%SZ");
			char *starttime = gmstrftime(rssitem.startdate, "%Y%m%dT%H%M%SZ");
			char *endtime = gmstrftime(rssitem.enddate, "%Y%m%dT%H%M%SZ");

			printf("BEGIN:VEVENT\n");
			printf("DTSTAMP: %s\n", pubdate);
			printf("DTSTART: %s\n", starttime);
			printf("DTEND: %s\n", endtime);
			if (rssitem.security == "pub")
				printf("CLASS: PUBLIC\n");
			else
				printf("CLASS: PRIVATE\n");
			printf("SUMMARY: %s\n", rssitem.title);
			if (sizeof(rssitem.guid) > 0)
				printf("UID:%s\n", rssitem.guid);
			if (sizeof(rssitem.link) > 0)
				printf("URL;VALUE=URI:%s\n", rssitem.link);
			if (sizeof(rssitem.description) > 0)
				printf("DESCRIPTION: %s\n", vcardencode(rssitem.description));
			printf("END:VEVENT\n");
		}
	}
}
%>
END:VCALENDAR
