<% 
#include "check.asp"
#include "dminfo.asp"

calpath = path + "/caldata";
view = findParameter($params, "view", "month");
origdate = getParameter($params, "origdate");
datetime = parsedate(date);

sdate = (int)getParameter($params, "starthour") * 3600 +
		(int)getParameter($params, "startmin") * 60;
rssfile = date + ".rss";

char *cmd = getParameter($params, "cmd"); 
recur = 0;
recurfreq = 0;
if (cmd == "add")
{
	recur = (int)findParameter($params, "recur", "0"); 
	recurfreq = (int)findParameter($params, "recurfreq", "0"); 
	if ((recur < 1) || (recur > 3) ||
		(recurfreq < 1) || (recurfreq > 30))
	{
		recur = 0;
		recurfreq = 0;
	}
}

int item = (int)findParameter($params, "item", "0"); 

host = getHostname($request);
url = "http://" + host;
if (envt("userdir") == "true")
	url = url + "/~" + envt("username");
else
	url = url + envt("userhome");

int updatable = docmgrUpdatable(calpath, rssfile);
if (updatable)
{
	// Moving a calendar entry?  Delete the old and add the new.
	if ((origdate != date) && (cmd == "upd"))
	{
		cmd = "add";
		origfile = buildpath(calpath, origdate + ".rss");
		char *origpath = getUserPath($request, origfile);
		try
		{
			origxml = XMLOpen(origpath, 0);
			if (origxml != NULL)
			{
				origrss = RSS(origxml);
				RSSSort(origrss, "startdate");
    			XMLFree(origxml);
				if ((origrss != NULL) && 
					(item > 0) && 
					(item <= sizeof(origrss.items)))
				{
					origrss.items[item - 1] = NULL;
					RSSSave(origrss, origpath);
				}
			}
		}
		catch (e)
		{
			// Ignore feed failres, just message below.
			write("<!--\n");
			write(exception(e, "info"));
			write("\n-->\n");
		}
	}
	
	rss = null;
	filename = buildpath(calpath, rssfile);
	char *userpath = getUserPath($request, filename);
	try
	{
		xml = XMLOpen(userpath, 1);
		if (xml != NULL)
		{
			rss = RSS(xml);
    		XMLFree(xml);
		}
	}
	catch (e)
	{
		// Ignore feed failres, just message below.
		write("<!--\n");
		write(exception(e, "info"));
		write("\n-->\n");
	}

	if ((cmd == "del") && 
		(rss != NULL) && 
		(item > 0) &&
		(item <= sizeof(rss.items)))
	{
		// If last element, delete RSS element
		if (sizeof(rss.items) == 1)
		{
			rm(userpath);
		}
		else
		{
			rss.items[item - 1] = NULL;
			RSSSave(rss, userpath);
		}
	}
	else if ((cmd == "upd") && 
		(sizeof(getParameter($params, "title")) > 0) &&
		(rss != NULL) && 
		(item > 0) &&
		(item <= sizeof(rss.items)))
	{
		olditem = rss.items[item - 1];
		struct RSSITEM myitem;
		myitem.guid = olditem.guid;
		assignItem(datetime, myitem);
		rss.items[item - 1] = myitem;
		RSSSort(rss, "startdate");
		RSSSave(rss, userpath);
	}
	else if ((cmd == "add") && 
		(sizeof(getParameter($params, "title")) > 0) &&
		(rss != NULL))
	{
		struct RSSITEM myitem;
		myitem.guid = uuid();
		assignItem(datetime, myitem);

		if (sizeof(rss.items) == 0)
			rss.items[] = { myitem };
		else
			rss.items[sizeof(rss.items)] = myitem;
		RSSSort(rss, "startdate");
		RSSSave(rss, userpath);

		newdate = datetime;
		for (r = 0; r < recurfreq; r++)
		{
			if (recur == 2)
			{
				// Weekly
				newdate += 604800;
				recurdate = gmstrftime(newdate, "%Y-%m-%d");
			}
			else if (recur == 3)
			{
				// Monthly
				mon++;
				if (mon > 12)
				{
					mon = 1;
					year++;
				}
				sprintf(recurdate, "%d-%02d-%02d", year, mon, day);
				newdate = parsedate(recurdate);
			}
			else
			{
				// Daily
				newdate += 86400;
				recurdate = gmstrftime(newdate, "%Y-%m-%d");
			}

			recurrss = null;
			recurname = buildpath(calpath, recurdate + ".rss");
			char *recurpath = getUserPath($request, recurname);
			try
			{
				recurxml = XMLOpen(recurpath, 1);
				if (recurxml != NULL)
				{
					recurrss = RSS(recurxml);
    				XMLFree(recurxml);
				}
			}
			catch (e)
			{
				// Ignore feed failres, just message below.
				write("<!--\n");
				write(exception(e, "info"));
				write("\n-->\n");
			}

			struct RSSITEM recuritem;
			recuritem.guid = uuid();
			assignItem(newdate, recuritem);
	
			if (sizeof(recurrss.items) == 0)
				recurrss.items[] = { recuritem };
			else
				recurrss.items[sizeof(recurrss.items)] = recuritem;
			RSSSort(recurrss, "startdate");
			RSSSave(recurrss, recurpath);
		}
	}
}

assignItem(int gmdate, void *rssitem)
{
	rssitem.title = getParameter($params, "title");
	rssitem.link = getParameter($params, "link");
	rssitem.description = getParameter($params, "content");
	rssitem.author = envt("username");
	rssitem.security = findParameter($params, "security", "pub");
	start = (int)getParameter($params, "starthour") * 3600 +
		(int)getParameter($params, "startmin") * 60 +
		timezone * 3600;
	rssitem.startdate = gmdate + start;
	end = start + (int)getParameter($params, "durhour") * 3600 +
		(int)getParameter($params, "durmin") * 60;
	rssitem.enddate = gmdate + end;
}

sendRedirect($response, home + "/index.asp?path=" + urlencode(path) +
	"&date=" + date + "&view=" + urlencode(view));
%>
