<% 
setContentType($response, "text/xml");

path = getParameter($params, "path");
id = getParameter($params, "id");
if ((sizeof(id) <= 0) || (sizeof(path) <= 0))
{
        printf("No ID or path provided.");
	exit;
}

view = findParameter($params, "view", "day");
timezone = (int)findParameter($params, "timezone", "0");

url = serveruri() + "/sysuser/calendar?path=" + path;

printf("<?xml version=\"1.0\" encoding=\"iso-8859-1\" ?>\n");
printf("<?xml-stylesheet type=\"text/css\" href=\"%s/sysuser/rss.css\" ?>\n",
    serveruri());
printf("<rss version=\"2.0\">\n");
printf("<channel><title>Calendar for %s</title>\n", envt("username"));
printf("<link>%s</link>\n", xmlencode(url));
printf("<description>%s Calendar</description>\n", xmlencode(view));
printf("<lastBuildDate>%s GMT</lastBuildDate>\n", envt("date_gmt"));
printf("<ttl>60</ttl>\n");

t = time();
if (view == "day")
{
	date = gmstrftime(t, "%Y-%m-%d");
	rssfile = path + "/caldata/" + date + ".rss";
	showItem(rssfile, 0);
}
else if (view == "week")
{
	wday = gmtime(t, "wday");
	for (day = 1; day < 8; day++)
	{
    	curt = t;
    	if (day < wday)
        	curt -= (86400 * (wday - day));
    	else if (day > wday)
        	curt += (86400 * (day - wday));

    	dy = gmtime(curt, "mday");
    	sprintf(curdate, "%d-%02d-%02d", 
			gmtime(curt, "year"), gmtime(curt, "mon"), dy);
		rssfile = path + "/caldata/" + curdate + ".rss";
		showItem(rssfile, 1);
	}
}
else if (view == "month")
{
	mon = gmtime(t, "mon");
	year = gmtime(t, "year"); 
	for (day = 1; day <= 31; day++)
	{
    	sprintf(curdate, "%d-%02d-%02d", year, mon, day);
		rssfile = path + "/caldata/" + curdate + ".rss";
		showItem(rssfile, 1);
	}
}

showItem(char *rssfile, int showdate)
{
	rss = null;
	try
	{
		char *userpath = getUserPathFromId($request, id, rssfile);
		if (userpath != null)
		{
			xml = XMLOpen(userpath, 0);
			if (xml != NULL)
			{
				rss = RSS(xml);
				RSSSort(rss, "startdate");
				XMLFree(xml);
			}
		}
	}
	catch (e)
	{
		write("<!--\n");
    	write(exception(e, "info"));
    	write("\n-->\n");
    	printf("RSS '%s' is not available or corrupt.", id);
		exit;
	}

	if ((rss != null) && (sizeof(rss.items) > 0))
	{
		for (i = 0; i < sizeof(rss.items); i++)
		{
			rssitem = rss.items[i];
			if (sizeof(rssitem.title) == 0)
    			continue;

			title = rssitem.title;
			if (strlen(title) >= 50)
			{
				title[46] = '.';
				title[47] = '.';
				title[48] = '.';
				title[49] = '\0';
			}

			char *datestr = NULL;
			int datetime = rssitem.pubDate;
			if (datetime > 0)
			{
				rectsec = gmtime(datetime, "tsec");
				datestr = strftime(datetime, "%a, %d %b %Y %T");
   			}
 			else
 			{
     			datestr = envt("date_gmt");
 			}

			char *starttime = NULL;
			if (showdate)
			{
				starttime = gmstrftime(rssitem.startdate + (-timezone * 3600),
    				"%a, %b %d %I:%M %p");
			}
			else
			{
				starttime = gmstrftime(rssitem.startdate + (-timezone * 3600),
    				"%I:%M %p");
			}

			endtime = gmstrftime(rssitem.enddate + (-timezone * 3600),
    			"%I:%M %p");

			printf("<item>\n");
			printf("<title>[%s - %s] %s</title>\n", 
				xmlencode(starttime), xmlencode(endtime), xmlencode(title));

			printf("<link>%s</link>\n", xmlencode(url));
			printf("<author>%s</author>\n", xmlencode(rssitem.author));
			printf("<description>");
			if (sizeof(rssitem.description) > 0)
				printf("%s", xmlencode(rssitem.description));
			printf("</description>\n");

			printf("<pubDate>%s GMT</pubDate>\n", datestr);
			printf("</item>\n");
		}
	}
}
%>
</channel>
</rss>
