<%
#include "check.asp"

vcards = NULL;
mcards = NULL;
try
{
    vcards = vcardOpen(vcf);

	if ((envt("mailserver") == "true") && (envt("havembox") == "true"))
    	mcards = vcardOpen("maildir");
}
catch (e)
{
    write("<!--\n");
    write(exception(e, "info"));
    write("\n-->\n");
}

setHeader($response, "Content-type", "text/csv");

printAdr(void *cards, void *card, void *attr)
{
    val = vcardAttrGet(vcards, vcard, attr);
    names = split(";", val);
    if (sizeof(names) > 0)
	{
		printf("%s ", txt2html(names[0]));
	}
    if (sizeof(names) > 3)
	{
		printf("%s - %s %s ", 
			txt2html(names[1]), txt2html(names[2]), txt2html(names[3]));
	}
    if (sizeof(names) > 4)
	{
		printf("%s", txt2html(names[4]));
	}

	if (vcardParamExists(vcards, vcard, attr, "work"))
		printf(" (Work)");
	else
		printf(" (Home)");

}

printTel(void *cards, void *card, void *attr)
{
    val = vcardAttrGet(vcards, vcard, attr);
	printf("%s", strsubst(val, ",", " ", 1));

	if (vcardParamExists(vcards, vcard, attr, "work"))
		printf(" (Work)");
	else if (vcardParamExists(vcards, vcard, attr, "cell"))
		printf(" (Cell)");
	else if (vcardParamExists(vcards, vcard, attr, "fax"))
		printf(" (Fax)");
	else if (vcardParamExists(vcards, vcard, attr, "home"))
		printf(" (Home)");

	if (vcardParamExists(vcards, vcard, attr, "pref"))
		printf(" (Pref)");
}

printEmail(void *cards, void *card, void *attr)
{
    val = vcardAttrGet(vcards, vcard, attr);
	printf("%s", strsubst(val, ",", " ", 1));

	if (vcardParamExists(vcards, vcard, attr, "pref"))
		printf(" (Pref)");
}

printCard(void *cards, void *card)
{
	name = null;
	val = vcardAttrGetValue(vcards, vcard, "n");
	if (sizeof(val) > 0)
	{
		names = split(";", val);
        if (sizeof(names) > 2)
        	name = names[1] + " " +names[2] + " " + names[0];
		else if (sizeof(names) > 1)
        	name = names[1] + " " + names[0];
		else if (sizeof(names) > 2)
        	name = names[0];
	}
	else
	{
		name = vcardAttrGetValue(cards, card, "fn");
	}

	printf("%s,", strsubst(name, ",", " ", 1));

	val = vcardAttrGetValue(cards, card, "title");
	if (sizeof(val) > 0)
		printf("%s", strsubst(val, ",", " ", 1));

	printf(",");

	val = vcardAttrGetValue(cards, card, "org");
	if (sizeof(val) > 0)
		printf("%s", strsubst(val, ",", " ", 1));

	printf(",");

	attrs = vcardAttrs(cards, card, "tel");
	for (j = 0; j < sizeof(attrs); j++)
		printTel(cards, card, attrs[j]);

	printf(",");

	attrs = vcardAttrs(cards, card, "email");
	for (j = 0; j < sizeof(attrs); j++)
		printEmail(cards, card, attrs[j]);

	printf(",");

	attrs = vcardAttrs(cards, card, "adr");
	for (j = 0; j < sizeof(attrs); j++)
		printAdr(cards, card, attrs[j]);

	printf(",");

	val = vcardAttrGetValue(cards, card, "url");
	if (sizeof(val) > 1)
		printf("%s", strsubst(val, ",", " ", 1));

	printf(",");

	val = vcardAttrGetValue(cards, card, "spouse");
	if (sizeof(val) > 1)
		printf("%s", strsubst(val, ",", " ", 1));

	printf(",");

	val = vcardAttrGetValue(cards, card, "bday");
	if (sizeof(val) > 1)
		printf("%s", strsubst(val, ",", " ", 1));
}

printf("Contacts for %s\r\n", envt("username"));
printf("Name, Title, Company, Phone, Email, Address, Url, Spouse, Birthday\r\n");

if (vcards != null) 
{
	list = vcardList(vcards);
	for (i = 0; i < sizeof(list); i++)
	{
		vcard = list[i];
		printCard(vcards, vcard);
		printf("\r\n");
	}
}

if (mcards != null) 
{
	list = vcardList(mcards);
	for (i = 0; i < sizeof(list); i++)
	{
		vcard = list[i];
		printCard(vcards, vcard);
		printf("\r\n");
	}
} 
%>
