<%
#include "check.asp"
area = "contacts";

vcards = NULL;
mcards = NULL;
try
{
    vcards = vcardOpen(vcf);

	if ((envt("mailserver") == "true") && (envt("havembox") == "true"))
    	mcards = vcardOpen("maildir");
}
catch (e)
{
    write("<!--\n");
    write(exception(e, "info"));
    write("\n-->\n");
}

printAdr(void *cards, void *card, void *attr)
{
    val = vcardAttrGet(vcards, vcard, attr);
    names = split(";", val);
    if (sizeof(names) > 0)
	{
		printf("%s<br>", txt2html(names[0]));
	}
    if (sizeof(names) > 3)
	{
		printf("%s, %s %s<br>", 
			txt2html(names[1]), txt2html(names[2]), txt2html(names[3]));
	}
    if (sizeof(names) > 4)
	{
		printf("%s", txt2html(names[4]));
	}

	if (vcardParamExists(vcards, vcard, attr, "work"))
		printf(" (Work)");
	else
		printf(" (Home)");

}

printTel(void *cards, void *card, void *attr)
{
    val = vcardAttrGet(vcards, vcard, attr);
	printf("%s", txt2html(val));

	if (vcardParamExists(vcards, vcard, attr, "work"))
		printf(" (Work)");
	else if (vcardParamExists(vcards, vcard, attr, "cell"))
		printf(" (Cell)");
	else if (vcardParamExists(vcards, vcard, attr, "fax"))
		printf(" (Fax)");
	else if (vcardParamExists(vcards, vcard, attr, "home"))
		printf(" (Home)");

	if (vcardParamExists(vcards, vcard, attr, "pref"))
		printf(" (Pref)");
}

printEmail(void *cards, void *card, void *attr)
{
    val = vcardAttrGet(vcards, vcard, attr);
	printf("<a href=\"mailto:%s\">%s</a>", txt2html(val), txt2html(val));

	if (vcardParamExists(vcards, vcard, attr, "pref"))
		printf(" (Pref)");
}

printCard(void *cards, void *card)
{
	name = null;
	val = vcardAttrGetValue(vcards, vcard, "n");
	if (sizeof(val) > 0)
	{
		names = split(";", val);
        if (sizeof(names) > 2)
        	name = names[1] + " " +names[2] + " " + names[0];
		else if (sizeof(names) > 1)
        	name = names[1] + " " + names[0];
		else if (sizeof(names) > 2)
        	name = names[0];
	}
	else
	{
		name = vcardAttrGetValue(cards, card, "fn");
	}

	printf("<p class=\"name\"><strong>%s</strong></p>", txt2html(name));

	even = 1;
	val = vcardAttrGetValue(cards, card, "title");
	if (sizeof(val) > 0)
	{
		printf("<p class=\"p-%s\">Title: %s</p>", 
			even ? "even" : "odd", txt2html(val));
		even = even ? 0 : 1; 
	}

	val = vcardAttrGetValue(cards, card, "org");
	if (sizeof(val) > 0)
	{
		printf("<p class=\"p-%s\">Company: %s</p>", 
			even ? "even" : "odd", txt2html(val));
		even = even ? 0 : 1; 
	}

	attrs = vcardAttrs(cards, card, "tel");
	for (j = 0; j < sizeof(attrs); j++)
	{
		printf("<p class=\"p-%s\">", even ? "even" : "odd");
		printTel(cards, card, attrs[j]);
		printf("</p>");
		even = even ? 0 : 1; 
	}

	attrs = vcardAttrs(cards, card, "email");
	for (j = 0; j < sizeof(attrs); j++)
	{
		printf("<p class=\"p-%s\">", even ? "even" : "odd");
		printEmail(cards, card, attrs[j]);
		printf("</p>");
		even = even ? 0 : 1; 
	}

	attrs = vcardAttrs(cards, card, "adr");
	for (j = 0; j < sizeof(attrs); j++)
	{
		printf("<p class=\"p-%s\">", even ? "even" : "odd");
		printAdr(cards, card, attrs[j]);
		printf("</p>");
		even = even ? 0 : 1; 
	}

	val = vcardAttrGetValue(cards, card, "url");
	if (sizeof(val) > 1)
	{
		printf("<p class=\"p-%s\"><a href=\"%s\">%s</a></p>", 
			even ? "even" : "odd", urlencode(val), txt2html(val));
		even = even ? 0 : 1; 
	}

	val = vcardAttrGetValue(cards, card, "spouse");
	if (sizeof(val) > 1)
	{
		printf("<p class=\"p-%s\">Spouse: %s</p>",
			even ? "even" : "odd", txt2html(val));
		even = even ? 0 : 1; 
	}

	val = vcardAttrGetValue(cards, card, "bday");
	if (sizeof(val) > 1)
	{
		printf("<p class=\"p-%s\">Birthdate: %s</p>",
			even ? "even" : "odd", txt2html(val));
		even = even ? 0 : 1; 
	}
}
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Contacts</title>
<link rel="stylesheet" href="/sysuser/style.css" type="text/css" />
<link rel="stylesheet" href="/sysuser/nav.css" type="text/css" />
	<h1>Contacts</h1>
	<% err = getParameter($params, "err");
	   if (sizeof(err) > 0) { 
	%>
		<BLOCKQUOTE>
		<div class="error"><B>Error! <%=err;%></B></div>
		</BLOCKQUOTE>
		<BR>
	<% } %>

	<% 
	col = 0;
	if (vcards != null) 
	{
		list = vcardList(vcards);
		for (i = 0; i < sizeof(list); i++)
		{
			vcard = list[i];
			if (col == 0)
			{
				printf("<table border=0 cellspacing=\"4\" width=\"100%\">\n");
				printf("<tbody><tr>");
			}
			printf("<td class=\"vcard\" valign=\"top\" width=\"50%\">\n");
			printCard(vcards, vcard);
			printf("</td>");
			col++;
			if (col > 1)
			{
				col = 0;
				printf("</tr></tbody></table>");
			}
		}

		if (col > 1)
			printf("</tr></tbody></table>");
	}

	if (mcards != null) 
	{
		list = vcardList(mcards);
		for (i = 0; i < sizeof(list); i++)
		{
			vcard = list[i];
			if (col == 0)
			{
				printf("<table border=0 cellspacing=\"4\" width=\"100%\">\n");
				printf("<tbody><tr>");
			}
			printf("<td class=\"vcard\" valign=\"top\" width=\"50%\">\n");
			printCard(vcards, vcard);
			printf("</td>");
			col++;
			if (col > 1)
			{
				col = 0;
				printf("</tr></tbody></table>");
			}
		}

		if (col > 1)
			printf("</tr></tbody></table>");
	} 
	%>
<br>
<% #include "../footer.asp" %>
