<% 
// Perform any delete/move/truncate message/folder actions.
try
{
	fld = imapFolderSelect(imap, folder);

	char *action = getParameter($params, "action");
	if (action == "truncate")
	{
    	char *name = getParameter($params, "name");
    	if (sizeof(name) > 0)
            imapFolderTruncate(imap, name);
	}
	else if (action == "delete")
	{
		uids = getParameters($params, "uid32");
		if (sizeof(uids) > 0)
		{
			uidstr = join(",", uids);
			imapMessageDelete(imap, fld, uidstr);
			sprintf(info, "Message(s) deleted from folder '%s'.", folder);
		}
	}
	else if (action == "move")
	{
		name = getParameter($params, "argument");
		uids = getParameters($params, "uid32");
		if ((sizeof(name) > 0) && (sizeof(uids) > 0))
		{
			uidstr = join(",", uids);
			imapMessageMove(imap, fld, uidstr, name);
			sprintf(info, "Message(s) moved from '%s' to '%s'.", folder, name);
		}
	}
	else if (action == "unread")
	{
		uids = getParameters($params, "uid32");
		if (sizeof(uids) > 0)
		{
			uidstr = join(",", uids);
			imapMessageFlag(imap, fld, uidstr, MESSAGE_FLAGS_UNREAD);
			sprintf(info, "Message(s) marked as unread.");
		}
	}
	else if (action == "read")
	{
		uids = getParameters($params, "uid32");
		if (sizeof(uids) > 0)
		{
			uidstr = join(",", uids);
			imapMessageFlag(imap, fld, uidstr, MESSAGE_FLAGS_READ);
			sprintf(info, "Message(s) marked as unread.");
		}
	}
	else if (action == "flag")
	{
		uids = getParameters($params, "uid32");
		if (sizeof(uids) > 0)
		{
			uidstr = join(",", uids);
			imapMessageFlag(imap, fld, uidstr, MESSAGE_FLAGS_FLAGGED);
			sprintf(info, "Message(s) flagged.");
		}
	}
	else if (action == "unflag")
	{
		uids = getParameters($params, "uid32");
		if (sizeof(uids) > 0)
		{
			uidstr = join(",", uids);
			imapMessageFlag(imap, fld, uidstr, MESSAGE_FLAGS_UNFLAGGED);
			sprintf(info, "Message(s) unflagged.");
		}
	}
}
catch (e)
{
	error = exception(e, "message");
}
%>
