<% 
setContentType($response, "text/xml");

id = getParameter($params, "id");
if ((id == null) || (sizeof(vhostProperty(envt("vhost"), "imailimap")) == 0))
{
	printf("No ID or mail server provided.");
	exit;
}

try
{
        imap = imapConnectById(vhostProperty(envt("vhost"), "imailimap"), id);
}
catch (e)
{
        write("<!--\n");
        write(exception(e, "info"));
        write("\n-->\n");
        printf("User mailbox is not available.");
        exit;
}

url = serveruri() + "/sysuser/imail";

folder = findParameter($params, "folder", "inbox");
fld = imapFolderSelect(imap, folder);
int nummsgs = imapFolderMessageCount(imap, fld, FOLDER_COUNT_ALL);
if (nummsgs > 20)
	nummsgs = 20;
msgs = NULL;
if (nummsgs > 0)
{
	msgs = imapMessages(imap, fld, 1, nummsgs, "desc");
}

printf("<?xml version=\"1.0\" encoding=\"iso-8859-1\" ?>\n");
printf("<?xml-stylesheet type=\"text/css\" href=\"%s/sysuser/rss.css\" ?>\n",
    serveruri());
printf("<rss version=\"2.0\">\n");
printf("<channel><title>%s for %s</title>\n", 
	urlencode(folder), imapUser(imap));
printf("<link>%s</link>\n", xmlencode(url));
printf("<description>Recent Mail</description>\n");
printf("<lastBuildDate>%s GMT</lastBuildDate>\n", envt("date_gmt"));
printf("<ttl>15</ttl>\n");

for (i = 0; i < sizeof(msgs); i++) 
{
	msg = msgs[i];

	addr = msg.fromstr;
	if (strlen(addr) >= 30)
	{
		addr[26] = '.';
		addr[27] = '.';
		addr[28] = '.';
		addr[29] = '\0';
	}

	subject = msg.subject;
	if (sizeof(subject) == 0)
		subject = "(no subject)";

	if (strlen(subject) >= 50)
	{
		subject[46] = '.';
		subject[47] = '.';
		subject[48] = '.';
		subject[49] = '\0';
	}

	char *datestr = NULL;
    int datetime = msg.datereceived;
    if (datetime > 0)
    {
        rectsec = gmtime(datetime, "tsec");
        datestr = strftime(datetime, "%a, %d %b %Y %T");
    }
    else
    {
        datestr = envt("date_gmt");
    }

	printf("<item>\n");
	printf("<title>%s - %s [%s]%s</title>\n", 
		xmlencode(addr), xmlencode(subject), getSize(msg.size, 0),
		msg.attachments > 0 ? "*" : "");

	sprintf(link, "%s/mailmsg.asp?folder=%s&uid32=%ld",
		url, folder, msg.uid);
	printf("<link>%s</link>\n", xmlencode(link));
	printf("<author>%s</author>\n", xmlencode(msg.from));

	printf("<pubDate>%s GMT</pubDate>\n", datestr);
	printf("</item>\n");
}

imapDisconnect(imap);
%>
</channel>
</rss>
