//               none      joins    talk       directed talk
var activity = ['#000000','#000099','#990000', '#009999'];

var IRCWindows = {};
var options = {};
var buddies = {};
var channels = {};
var currentuser = '';
var currentwindow = '';
var lastwindow = '';
var connected = 1;
var prefixchars = '@*%+- ';

function doFocus() 
{
	load();
}

function doUnFocus() 
{
	do_quit();
}


function ircwindow(name, channel) 
{
	if (IRCWindows[name] || findwin(name)) 
		return;

	name = name.replace(/\"/g, '&quot;');

	IRCWindows[name] = { activity: 0, text: new Array, channel: channel, speak: 1,  info: 0 };
	if (channel) 
	{
		IRCWindows[name].users = {};
		IRCWindows[name].topic = '';
	}

	if (!currentwindow) 
		currentwindow = name;

	irclistredraw();
}

function ircnospeak(name) 
{
	if (!IRCWindows[name] && !(name = findwin(name))) 
		return;
	IRCWindows[name].speak = 0;
}

function ircinfo(name) 
{
	if (!IRCWindows[name] && !(name = findwin(name))) 
		return;
	IRCWindows[name].info = 1;
}

function ircpart(name) 
{
	if (!IRCWindows[name] && !(name = findwin(name))) 
		return;
	if (name == 'Status') 
		return;
	webirc_command("part " + name);
	delete IRCWindows[name];
	if (currentwindow == name) 
		ircchange(lastwindow ? lastwindow : 'Status');
}

function ircclear(name) 
{
	if (!IRCWindows[name] && !(name = findwin(name))) 
		return;
	IRCWindows[name].text.length = 0;
	ircredraw();
}


function addbuddy(user) 
{
	var o = user.substr(0,1);
	if (prefixchars.lastIndexOf(o) != -1)
		user = user.substr(1);

	buddies[user] = { };
	
	if (o == '+') 
		buddies[user].online = 1;
	else 
		buddies[user].online = 0;
}

function addchannel(name, count, topic) 
{
	channels[name] = { };

	channels[name].count = count;
	channels[name].topic = topic;
	channellist();
}

function addchanneluser(channel, user) 
{
	if (!IRCWindows[channel] && !(channel = findwin(channel))) 
		return;

	var o = user.substr(0,1);
	if (prefixchars.lastIndexOf(o) != -1)
		user = user.substr(1);

	IRCWindows[channel].users[user] = { };
	
	if (o == '@') 
		IRCWindows[channel].users[user].op = 1;
	else if(o == '%') 
		IRCWindows[channel].users[user].halfop = 1;
   	else if(o == '+') 
		IRCWindows[channel].users[user].voice = 1;
	else if(prefixchars.lastIndexOf(o) != -1)
		IRCWindows[channel].users[user].other = o;
}

function delchannel(name) 
{
	if (!channels[name])
		return;
	delete channels[name];
	channellist();
}

function delchanneluser(channel, user) 
{
	if (!IRCWindows[channel] && !(channel = findwin(channel))) 
		return;

	var o = user.substr(0,1);
	if (prefixchars.lastIndexOf(o) != -1)
		user = user.substr(1);

	delete IRCWindows[channel].users[user];

	if (user == currentuser)
	{
		delete IRCWindows[channel];
		if (currentwindow == channel) 
			ircchange(lastwindow ? lastwindow : 'Status');
	}
}

function channelusers(channel) 
{
	if (!IRCWindows[channel] && !(channel = findwin(channel))) 
		return;

	var users = new Array();

	for (var i in IRCWindows[channel].users) 
	{
		var user = IRCWindows[channel].users[i];
		if(user.other) 
			i = user.other + i;
		else if(user.op == 1) 
			i = '@' + i
		else if(user.halfop == 1) 
			i = '%' + i;
		else if(user.voice == 1) 
			i = '+' + i;
		else   
			i = ' ' + i;

		users[users.length] = i;
	}

	users = users.sort(usersort);
	return users;
}

function usersort(user1,user2) 
{
	var m1 = user1.substr(0,1);
	var m2 = user2.substr(0,1);

	if (m1 == m2) {
		if (user1.toUpperCase() < user2.toUpperCase()) 
			return -1;
		if (user2.toUpperCase() < user1.toUpperCase()) 
			return 1;
		return 0;
	} else if(m1 == '@') {
		return -1;
	} else if(m2 == '@') {
		return 1;
	} else if(m1 == '%') {
		return -1;
	} else if(m2 == '%') {
		return 1;
	} else if(m1 == '+') {
		return -1;
	} else if(m2 == '+') {
		return 1;
	} else {
		if (user1.toUpperCase() < user2.toUpperCase()) 
			return -1;
		if (user2.toUpperCase() < user1.toUpperCase()) 
			return 1;
		return 0;
	}
}

function ircchange(name) 
{
	if (!IRCWindows[name] && !(name = findwin(name))) 
		name = 'Status';
	if (IRCWindows[name].activity > 0) 
		IRCWindows[name].activity = 0;
	lastwindow = (IRCWindows[currentwindow] ? currentwindow : 'Status');
	currentwindow = name;
	irclistredraw();
	ircredraw();
	load();
	userlist();
	buddylist();
	channellist();
	retitle();
}

function retitle() 
{
	document.title = 'IRC - ' + (IRCWindows[currentwindow].info ? currentwindow.substr(1) : currentwindow) + (IRCWindows[currentwindow].channel == 1 ? ' [' + countit(IRCWindows[currentwindow].users) + '] ' : '');
}

function setoption(option, value) 
{
	options[option] = value;
	if (option == 'font')
		document.getElementById('text').style.fontFamily = font;
	if (option == 'user')
		currentuser = value;
}

function countit(obj) 
{
	var i = 0;
	for(var foo in obj) 
		i++;
	return i;
}

function ircmsg(name, text, activity, redraw) 
{
	if (name == '-all') 
	{
		for (var window in IRCWindows) 
		{
			if (IRCWindows[window].info) 
				continue;
			ircmsg(window, text, activity, redraw);
		}
		return;
	}

	if (!IRCWindows[name] && !(name = findwin(name))) 
	{
		if (!IRCWindows["Status"]) 
			return;
		name = "Status";
	}
   
	if (options["timestamp"] == 1 && !IRCWindows[name].info) 
	{
		var D = new Date();
		text = '[' + (D.getHours() < 10 ? '0' + D.getHours() : D.getHours()) + ':' + (D.getMinutes() < 10 ? '0' + D.getMinutes() : D.getMinutes()) + '] ' + text;
	}
  
	if (!IRCWindows[name].info)
		text = "<div class='main-item'>" + text + "</div>";

	IRCWindows[name].text[IRCWindows[name].text.length] = text;

	if (currentwindow != name && activity > IRCWindows[name].activity)
		ircactivity(name, activity);
	if(redraw != 0 && currentwindow == name) 
		ircredraw();

	if (name == "Status")
		ircchange(name);
}

function ircactivity(name, activity) 
{
	if(!IRCWindows[name] && !(name = findwin(name))) 
		return;
	IRCWindows[name].activity = activity;
	irclistredraw();
}

function ircredraw() 
{
	if (!currentwindow) 
		currentwindow = 'Status';

	document.getElementById('status').innerHTML = 
		'<b><font color=#ffffff>' + 
		currentuser + '</b>  &gt;&gt; <b>' + currentwindow + 
		'</font></b>';

	if (currentwindow != 'Status')
	{
		document.getElementById('actions').innerHTML = '<b><a href="javascript:ircclear(\'' + currentwindow + '\');"><font color=#ffffff>Clear</font></A>&nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:ircpart(\'' + currentwindow + '\');"><font color=#ffffff>Quit</font></a></b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
	}
	else
	{
		document.getElementById('actions').innerHTML = '';
	}

	document.getElementById('text').innerHTML = IRCWindows[currentwindow].text.join('');
}

function irclistredraw() 
{
	var output='';
	for (var i in IRCWindows) 
	{
		output += '<span class="' + (i == currentwindow ? 'active' : 'chooser') + '" style="color: ' + activity[IRCWindows[i].activity] + ';" onclick="ircchange(\'' + (i == currentwindow ? escapejs(lastwindow) : escapejs(i)) + '\')" onmouseover="this.className = \'mouseover\'" onmouseout="this.className = \'' + (i == currentwindow ? 'active' : 'chooser') + '\'">' + escapehtml(IRCWindows[i].info ? i.substr(1) : i) + '</span>\r\n';
	}

	document.getElementById('windowlist').innerHTML = output;
}

function findwin(name) 
{
	var wname = new String(name);
	wname = wname.replace(/\"/g, '&quot;');
	for (var i in IRCWindows) 
	{
		if (i.toUpperCase() == wname.toUpperCase())
			return i;
	}

	return false;
}

function escapejs(string) 
{
	out = string.replace(/\\/g,'\\\\').replace(/\'/g, '\\\'').replace(/\"/g, '&quot;');
	return out;
}

function escapehtml(string) 
{
	var out = string;
	out = out.replace(/</g, '&lt;');
	out = out.replace(/>/g, '&gt;');
	out = out.replace(/\"/g, '&quot;');
	return out;
}

function reconnect() 
{
	do_quit();
	IRCWindows = { };
	document.getElementById('iframe').src = document.getElementById('iframe').src + '&xx=yy';
}

function sendcmd(cmd) 
{
	if (cmd.substr(0, 10) == '/reconnect') 
	{
		reconnect();
		return;
	}

	if (!connected && cmd.substr(0,5) != '/quit') 
	{
		alert('Not connected to IRC!');
		return;
	}

	// Sending an IRC command down?
	if (cmd.substr(0,1) == '/') 
	{
		webirc_command(cmd.substr(1)); 
		return;
	}

	// Send the message to the user or channel.	
	if (IRCWindows[currentwindow] && IRCWindows[currentwindow].speak)
	{
		webirc_command("privmsg " + currentwindow + " " + cmd); 
		return;
	}
}

function webirc_command(cmd) 
{
	document.webirc.command.value = cmd;
	document.webirc.submit();
}

function senditem(item) 
{
	alert("senditem " + item);
}

function channellist() 
{
	var clist = new Array();
	for (var i in channels) 
		clist[clist.length] = i;

	clist.sort(channelsort);
	channelout(clist);
}

function channelsort(channel1,channel2)
{
   if (channel1.toUpperCase() < channel2.toUpperCase())
      return -1;
   if (channel2.toUpperCase() < channel1.toUpperCase())
      return 1;
   return 0;
}

function buddylist() 
{
	var blist = new Array();
	for (var i in buddies) 
	{
		var buddy = buddies[i];
		if (buddy.online)
        	i = '+' + i
        else
        	i = '-' + i;

		blist[blist.length] = i;
	}

	blist.sort(buddysort);
	buddyout(blist);
}

function buddysort(buddy1,buddy2)
{
    var m1 = buddy1.substr(1);
    var m2 = buddy2.substr(1);

    if (m1.toUpperCase() < m2.toUpperCase())
        return -1;
    if (m2.toUpperCase() < m1.toUpperCase())
        return 1;
    return 0;
}

function userlist() 
{
	if (IRCWindows[currentwindow] && IRCWindows[currentwindow].channel == 1) 
	{
		userlistupdate(channelusers(currentwindow));
	} 
	else 
	{
		userlistupdate([' No channel']);
	}

	retitle();
}

function userlistupdate(list) 
{
	userout(list);
}

function disconnected() 
{
	do_quit();
	ircmsg('-all', '<b>Disconnected</b>', 1, 1);
}

function doinfowin(name, text) 
{
	ircwindow(name, 0);
	ircnospeak(name);
	ircinfo(name);
	ircclear(name);
	ircmsg(name, text, 0, 1);
	ircchange(name);
}

function do_quit() 
{
	if (connected == 1) 
	{
		sendcmd('/quit');
	}

	connected = 0;
}

function t(item,text) 
{
    if (item.style.display == 'none') 
    {
		item.style.display = 'inline';
		text.value = '>>';
		document.myform.say.style.width='60%'
    } 
    else 
    {
		item.style.display = 'none';
		text.value = '<<';
		document.myform.say.style.width='90%'
	}

    document.myform.say.focus();
}

function load() 
{
	if (!document.myform)
		return;
    document.myform.say.focus();
}

function append(a) 
{
	document.myform.say.value += a;
	document.myform.say.focus();
}

function cmd() 
{
    if (document.myform.say.value.length < 1) 
		return false;
    sendcmd(document.myform.say.value);
    document.myform.say.value = ''
    document.myform.say.focus();
    return false;
}

//
// Channel Panel
//
var channelSelected;

function channelSubmit(form) 
{
	var channel = form.channel.value;

	if (!channel)
	{
		alert("No channel selected");
		return false;
	}

	webirc_command("join " + channel);
	ircchange(channel) 
	return false;
}

function channelDeselect() 
{
	if (!channelSelected) 
		return;
	channelSelected.className = 'list-item';
}

function channelout(channels) 
{
	if (!channels)
		return;
	var tmp = '<table class="list-table">';
	for (var i = 0; i < channels.length; i++) 
	{
		var channel = channels[i];

		tmp += '<tr><td class="list-item" ' + 
          	' onmouseout="this.className=(this == channelSelected ?' + 
			'\'list-selected\':\'list-item\')"' + 
			' onmouseover="this.className=\'list-hover\'"' + 
			' onclick="' + 'this.className=\'list-selected\';' + 
			'channelDeselect();channelSelected = this;document.channelform.channel.value = \'' + 
			escapejs(channel) + '\';return false;" ' +
			'ondblclick="channelSubmit(document.channelform);"' + '>' + 
			channel + '</td></tr>';
	}
	tmp += '</table>';
	document.getElementById('channeltable').innerHTML = tmp;
	document.channelform.channel.value = '';
}

//
// Buddy Panel
//
var buddySelected;

function buddySubmit(form) 
{
	var action = form.action.options[form.action.selectedIndex].value;
	var user = form.user.value;

	if (!user || !action) 
	{
		alert("No user or action selected");
		return false;
	}

	var o = user.substr(0,1);
	if (prefixchars.lastIndexOf(o) != -1)
		user = user.substr(1);
	if (action == "privmsg")
	{
		ircwindow(user, '0');
		sendcmd("/privmsg " + user + " :...");
	}
	else
	{
		sendcmd("/" + action + " " + user);
	}
	return false;
}

function buddyDeselect() 
{
	if (!buddySelected) 
		return;
	buddySelected.className = 'list-item';
}

function buddyout(users) 
{
	if (!users)
		return;
	var tmp = '<table class="list-table">';
	for (var i = 0; i < users.length; i++) 
	{
		var status = users[i].substr(0, 1);
		var user = users[i].substr(1);

		tmp += '<tr><td>' + buddyimage(status) + ' </td>' + 
			'<td class="list-item" ' + (user != 'No list' ? 
          	' onmouseout="this.className=(this == buddySelected ?' + 
			'\'list-selected\':\'list-item\')"' + 
			' onmouseover="this.className=\'list-hover\'"' + 
			' onclick="' + 'this.className=\'list-selected\';' + 
			'buddyDeselect();buddySelected = this;document.buddyform.user.value = \'' + 
			escapejs(user) + '\';return false;" ' +
			'ondblclick="buddySubmit(document.buddyform);"' : '') + '>' + 
			user + '</td></tr>';
	}

	tmp += '</table>';
	document.getElementById('buddytable').innerHTML = tmp;
	document.buddyform.user.value = '';
}

function buddyimage(status) 
{
	if(status == "+") 
	{
		return '<img src="/sysimage/webirc/online.gif">';
	}
	else if (status == "-") 
	{
		return '<img src="/sysimage/webirc/offline.gif">';
	}
	else
	{
      return '';
	}
}

//
// User Panel
//
var userSelected;

function usersSubmit(form) 
{
	var action = form.action.options[form.action.selectedIndex].value;
	var user = form.user.value;

	if (!user || !action) 
	{
		alert("No user or action selected");
		return false;
	}

	var o = user.substr(0,1);
	if (prefixchars.lastIndexOf(o) != -1)
		user = user.substr(1);
	if (action == "privmsg")
	{
		ircwindow(user, '0');
		sendcmd("/privmsg " + user + " :...");
	}
	else
	{
		sendcmd("/" + action + " " + user);
	}
	return false;
}

function userDeselect() 
{
	if (!userSelected) 
		return;
	userSelected.className = 'list-item';
}

function userout(users) 
{
	if (!users)
		return;
	var tmp = '<table class="list-table">';
	for (var i = 0; i < users.length; i++) 
	{
		var status = users[i].substr(0, 1);
		var user = users[i].substr(1);

		tmp += '<tr><td class="list-status"> ' + 
			userhtml(status) + ' </td>' + 
			'<td class="list-item" ' + (user != 'No channel' ? 
          	' onmouseout="this.className=(this == userSelected ?' + 
			'\'list-selected\':\'list-item\')"' + 
			' onmouseover="this.className=\'list-hover\'"' + 
			' onclick="' + 'this.className=\'list-selected\';' + 
			'userDeselect();userSelected = this;document.userform.user.value = \'' + 
			escapejs(user) + '\';return false;" ' +
			'ondblclick="usersSubmit(document.userform);"' : '') + '>' + 
			user + '</td></tr>';
	}
	tmp += '</table>';
	document.getElementById('usertable').innerHTML = tmp;
	document.userform.user.value = '';
}

function userhtml(status) 
{
	if(status == "@") 
	{
		return '<div class="list-op">@</div>';
	}
	else if(status == "+") 
	{
		return '<div class="list-voice">+</div>';
	}
	else if(status == "%") 
	{
		return '<div class="list-halfop">%</div>';
	}
	else
	{
      return '';
	}
}
