<% 
setContentType($response, "text/xml");

id = getParameter($params, "id");
if ((id == null) || (envt("mailserver") != "true"))
{
        printf("No ID provided.");
	exit;
}

try
{
	mbox = mboxOpenById(id);
}
catch (e)
{
        write("<!--\n");
        write(exception(e, "info"));
        write("\n-->\n");
        printf("Mailbox '%s' is not available or corrupt.", id);
	exit;
}

url = serveruri() + "/sysuser/mail";

folder = findParameter($params, "folder", "inbox");
fld = mboxFolder(mbox, folder);
int nummsgs = folderMessageCount(fld, FOLDER_COUNT_UNDELETED);
if (nummsgs > 20)
	nummsgs = 20;
msgs = NULL;
if (nummsgs > 0)
{
	msgs = folderMessages(fld, 1, nummsgs, "all", "desc");
}

printf("<?xml version=\"1.0\" encoding=\"iso-8859-1\" ?>\n");
printf("<?xml-stylesheet type=\"text/css\" href=\"%s/sysuser/rss.css\" ?>\n",
    serveruri());
printf("<rss version=\"2.0\">\n");
printf("<channel><title>%s for %s</title>\n", xmlencode(folder),
	getUserFromId($request, id));
printf("<link>%s</link>\n", xmlencode(url));
printf("<description>Recent Mail</description>\n");
printf("<lastBuildDate>%s GMT</lastBuildDate>\n", envt("date_gmt"));
printf("<ttl>15</ttl>\n");

for (i = 0; i < sizeof(msgs); i++) 
{
	msgcache = messageHeaderCache(fld, msgs[i]);
	int msgno = messageId(fld, msgs[i]);

	addr = msgcache.from;
	if (strlen(addr) >= 30)
	{
		addr[26] = '.';
		addr[27] = '.';
		addr[28] = '.';
		addr[29] = '\0';
	}

	subject = msgcache.subject;
	if (sizeof(subject) == 0)
		subject = "(no subject)";

	if (strlen(subject) >= 50)
	{
		subject[46] = '.';
		subject[47] = '.';
		subject[48] = '.';
		subject[49] = '\0';
	}

	char *datestr = NULL;
	int datetime = msgcache.daterecieved;
	if (datetime > 0)
	{
		rectsec = gmtime(datetime, "tsec");
		datestr = strftime(datetime, "%a, %d %b %Y %T");
   	}
 	else
 	{
     	datestr = envt("date_gmt");
 	}

	printf("<item>\n");
	printf("<title>%s - %s [%s]%s</title>\n", 
		xmlencode(addr), xmlencode(subject), getSize(msgcache.size, 0),
		msgcache.attachments > 0 ? "*" : "");

	sprintf(link, "%s/mailmsg.asp?folder=%s&msgno=%ld&uid32=%ld",
		url, folder, msgno, msgcache.uid32);
	printf("<link>%s</link>\n", xmlencode(link));
	printf("<author>%s</author>\n", xmlencode(msgcache.from));

	printf("<pubDate>%s GMT</pubDate>\n", datestr);
	printf("</item>\n");
}

mboxClose(mbox);
%>
</channel>
</rss>
